DebugFrame (rhino 1.7.7.2 API)
Date: 2017-09-27

org.mozilla.javascript.debug

## Interface DebugFrame

- All Known Implementing Classes:
    Dim.StackFrame

      public interface DebugFrame

  Interface to implement if the application is interested in receiving debug information during execution of a particular script or function.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `onDebuggerStatement(Context cx)` Called when the function or script executes a 'debugger' statement.
    `void` | `onEnter(Context cx, Scriptable activation, Scriptable thisObj, java.lang.Object[] args)` Called when execution is ready to start bytecode interpretation for entered a particular function or script.
    `void` | `onExceptionThrown(Context cx, java.lang.Throwable ex)` Called when thrown exception is handled by the function or script.
    `void` | `onExit(Context cx, boolean byThrow, java.lang.Object resultOrException)` Called when the function or script for this frame is about to return.
    `void` | `onLineChange(Context cx, int lineNumber)` Called when executed code reaches new line in the source.

- - ### Method Detail

    - #### onEnter

          void onEnter(Context cx,
                       Scriptable activation,
                       Scriptable thisObj,
                       java.lang.Object[] args)

      Called when execution is ready to start bytecode interpretation for entered a particular function or script.
      Parameters:
        `cx` - current Context for this thread
        `activation` - the activation scope for the function or script.
        `thisObj` - value of the JavaScript `this` object
        `args` - the array of arguments

    - #### onLineChange

          void onLineChange(Context cx,
                            int lineNumber)

      Called when executed code reaches new line in the source.
      Parameters:
        `cx` - current Context for this thread
        `lineNumber` - current line number in the script source

    - #### onExceptionThrown

          void onExceptionThrown(Context cx,
                                 java.lang.Throwable ex)

      Called when thrown exception is handled by the function or script.
      Parameters:
        `cx` - current Context for this thread
        `ex` - exception object

    - #### onExit

          void onExit(Context cx,
                      boolean byThrow,
                      java.lang.Object resultOrException)

      Called when the function or script for this frame is about to return.
      Parameters:
        `cx` - current Context for this thread
        `byThrow` - if true function will leave by throwing exception, otherwise it will execute normal return
        `resultOrException` - function result in case of normal return or exception object if about to throw exception

    - #### onDebuggerStatement

          void onDebuggerStatement(Context cx)

      Called when the function or script executes a 'debugger' statement.
      Parameters:
        `cx` - current Context for this thread